#! /usr/bin/perl -w
#
# un_commentLines.pl - 	Comments or uncomments the selected lines
#			Uses '# ' for Perl and shell scripts; '// ' otherwise
#
# -- PB User Script Info --
# %%%{PBXName=Un/Comment Selection}%%%
# %%%{PBXInput=Selection}%%%
# %%%{PBXOutput=ReplaceSelection}%%%
# %%%{PBXKeyEquivalent=@/}%%%
#

my $perlCmt = "#";
my $cCmt = "//";

my $fileString = <<'ALLTEXT';
%%%{PBXAllText}%%%
ALLTEXT

my $selection = <<'SELECTION';
%%%{PBXSelectedText}%%%
SELECTION

chomp $selection;

# determine the type of file we have by looking for the #! line at the top
# careful--it might already be commented out!
my $commentString;
if ($fileString =~ m!^($perlCmt|$cCmt)?#\!\s*.*?/perl|^($perlCmt|$cCmt)?#\!\s*.*?/sh!) {
	$commentString = $perlCmt;
} else {
	$commentString = $cCmt;
}

# add or remove comment markers depending on the state of the first line of the selection
# if it is uncommented, comment all lines.  If it is commented, remove comment markers, if present
if ($selection =~ /^$commentString/) {
	$selection =~ s/^$commentString//gm;
} else {
	$selection =~ s/^/$commentString/gm;
}

print "%%%{PBXSelection}%%%";
print $selection;
print "%%%{PBXSelection}%%%";
